# xivo-install-ansible

Install xivo using ansible playbooks

# Usage

This installer installs xivo to docker swarm cluster.
Install this package on server which has access to your new xivo servers
(installer server). Installer server can be one of new xivo servers.
Run xivo-install.py


## Prerequisities

You need 
- proper number of servers with basic debian installation.
- acces using ssh-key to each server from installer server


## Currently supported deployments are 
- xivo only on 1 server
- xivo UC on 1 or 2 servers
- xivo CC on 1 - 4 servers

MDS installation is work in progress

## Installation process

xivo-install.py uses simple TUI interface to gather information about desired
deployment.

1/ xivo parts installed and number of servers
Select which xivo parts should be installed and how meny servers to use.

2/ IPs of servers
Insert public IPs of xivo servers. Never use localhost or similar addresses
even if your installer server is one of xivo servers.

3/ Select VoIP deployment type
This is method, how to solve networkong problems of several services with
speacial netvork communication
- astersik - needs to expose too many UDP for RTP
- provd - for TFTP needs to expose many udp ports
- dhcpd - needs to receive dhcp request broadcasts

There are 3 medhods how to solve this problems
- run these thing on host, not in container
- use ingress anyway for asterisk and provd, expose know reanges of ports, run dhcpd on host
- ipvlan - connect containers to docker ipvlan network associated with one of host interfaces.

In this moment all 3 methods are at least partially implemented, but main
focus is on ipvlan method, which allows to have everything in containers and communicating
on overlay network and in same time does not have a problem with ports exposion.
 
ipvlan network configuration specific parameters
- voip network
parameter --subnet of docker network create command
it must be network on the parent interface of the ipvlan network
- voip dummy range
parameter --ip-range  of docker netvork create command
it is ip block which is used for allocation of ip addresses for containers
connected to the network. Addresses asigned to asterisk and provd container
are not used by xivo, beacause we cannot controll which ip will be assigned.
Instead, additional addresses defined for asterisk and provd are confiuged on peoper interface in
container during entrypoint.
- asterisk IP address
ip address assigned to asterisk container. Must be outside of "voip dummy
range" to avoid ip conflicts
- provd IP address
ip address assigned to provd container. Must be outside of "voip dummy
range" to avoid ip conflicts
- GW IP
default route in ipvlan network. If host default route is in ipvlan subnet,
this field can be left empty and address will be found automatically
- voip interface name
parameter -o parent= parameter of docker nework create command
Can be left empty unless you want to create new VLAN interface for the
ipvlan network. It such case interface name must be standtard vlan interface
name (like ens192.200 for parent interface ens192 and vlan 200)
- dhcp range start
first ip of address range available for dhcp
- dhcp range end
last ip of address range available for dhcp
- DHCP router
options routers for DHCP server













